#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>




/*
base 0 write 0-7
base 1 read 0-7, write to clear COS (port A)
base 2 read to enable IRQ, write to disable IRQ
base 3 read to detect COS, must be done before writing to base+1

base+4 write 8-15
base+5 read 8-15 (port B)
base+6 read to detect COS must be done before writing to base +1
base+7 read the COS and IRQ status
       d0 port a COS, d1=port b COS, d1=IRQassert,d7=IRQenabled
*/

#define base 0x300

void main (void)
{
    unsigned char a=0,oa=0,ccosa=0,b=0,ob=0,ccosb=0,as=0,bs=0,coss=0;

    clrscr();
    puts("104-IDIO-16 engineering test program - poll COS operation");
    /*
        Program overview:

        Poll bits 0-15, status registers at +1 +6, and +7, and
        indicate pass/fails on screen.
    */

    oa = inportb(base+1);
    ob = inportb(base+5);
    while( !kbhit() )
    {
        gotoxy(1,5);

        a = inportb(base+1);
        b = inportb(base+5);

        ccosa = a ^ oa;
        ccosb = b ^ ob;

        as = inportb(base+3);outportb(base+3,0);
        bs = inportb(base+6);outportb(base+6,0);

        coss = inportb(base+7);

        gotoxy(1,15);
        if (ccosa != as){
            printf("calculated change doesn't match status register on port a: %02X!=%02X\r\n",ccosa,as);
        }else clreol();
        puts("");
        if (ccosb != bs)
            printf("calculated change doesn't match status register on port b: %02X!=%02X\r\n",ccosb,bs);
        else
            clreol();
        puts("");
        if (ccosa && (!(coss&0x01)))
            printf("base+7 doesn't indicate COS on port A but calculation expects it: +7=%02X\r\n",coss);
        else
            clreol();
        puts("");

        if (ccosb && (!(coss&0x02)))
            printf("base+7 doesn't indicate COS on port B but calculation expects it: +7=%02X\r\n",coss);
        else
            clreol();

        printf("base1    base3    base5     base6   base7\r\n");
        printf("portA:%02X COSA:%02X portB:%02X COSB:%02X stat7:%02X\r\n",a,as,b,bs,coss);
        printf("old A:%02X calc:%02X old B:%02X calc:%02X\r\n",oa,oa^a,ob,ob^b);

        oa = a;
        ob = b;

    }//end main program loop




}