/*****************************************************************************
 *  This sample program will sequentially turn on all bits of the relay input
 *  and sequentially turns them off.  Each time it sets a new bit, both the   *
 *  relay output and the iso input are read and the data displayed.  This
 *  demonstrates how to read and write to a port.
*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#define TRUE  1
#define FALSE 0

unsigned int base;


unsigned AskForBaseAddress(unsigned int OldOne)
{
	char msg[7];
	int NewOne = 0, Success = 0, Dummy;
	int AddrInputPosX, AddrInputPosY;

	puts("\nPlease enter the Base Address for your card (in hex)");
	printf("or press ENTER for %X.\n>", OldOne);
	AddrInputPosX = wherex(); AddrInputPosY = wherey();
	do {
      gotoxy(AddrInputPosX, AddrInputPosY);
      clreol();
      msg[0] = 5; msg[1] = 0;
      cgets(msg);
      sscanf(msg + 2, "%x", &NewOne);
      Success = 1;
      Dummy = NewOne;
		if (msg[1] == 0) {
        gotoxy(AddrInputPosX, AddrInputPosY);
        printf("%X", OldOne);
        Success = 1;
        Dummy = OldOne;
      }
	} while(!Success);
	return (Dummy);
} /* end of AskForBaseAddress */

void printbits(char foo)
{ int i;
  for(i=7;i>=0;i--){
    if (foo & (1<<i))
      putch('1');
    else
      putch('0');
  }
}

void main()
{
   unsigned int i,dig,opto,out,out2;

   clrscr();
   puts(" 104-IIRO-8 Sample Program.");
   puts("This sample program will sequentially turn on all bits of the relay input");
   puts("and sequentially turns them off.  Each time it sets a new bit, both the ");
   puts("relay output and the relay input are read and the data displayed.  This");
   puts("demonstrates how to read and write to a port, and to use the read back");
   puts("function of the board.");
   base=AskForBaseAddress(0x300);
   clrscr();
   puts("\n\n\nBoard Configuration:\n");
   printf(" -- Base Address is %X hex\n",base);
   gotoxy(1,10);
   puts("    RELAY  OUTPUT          OPTO INPUT ");
   puts(" ------------------    ------------------ ");
   i=0;

   do{
      if (i < 8) {
          out2 = 0;
          out = 1 << i;
      } else {
          out = 0;
          out2 = 1 << (i % 8);
      }
      if (i < 8) outportb(base,out); else outportb(base+4,out2);
      delay(200);

      opto = inportb(base+1);
      dig = inportb(base+5);

      i++;
      i %= 16;

      gotoxy(11,12);
      printbits(out);
      gotoxy(3,12);
      printbits(out2);
      gotoxy(34,12);
      printbits(opto);
      gotoxy(26,12);
      printbits(dig);
      delay(300);
   }while(!kbhit());
}


